=== modified file 'utilities/rocketfuel-get'
--- utilities/rocketfuel-get	2011-05-29 06:33:23 +0000
+++ utilities/rocketfuel-get	2011-06-01 09:02:19 +0000
@@ -10,6 +10,9 @@
 # Stop if there's an error, and treat unset variables as errors.
 set -eu
 
+# A rough measure of how much stuff we can do in parallel.
+CPU_COUNT="$(egrep -c '^processor\b' /proc/cpuinfo)"
+
 # Helper function to run a child process, indenting stdout to aid
 # readability.
 run-child() {
@@ -56,23 +59,18 @@
 fi
 
 echo "Updating sourcecode dependencies in rocketfuel:"
-echo ""
-echo "    Sourcedeps: $LP_SOURCEDEPS_PATH"
-
-run-child $LP_TRUNK_PATH/utilities/update-sourcecode $LP_SOURCEDEPS_PATH $sourcedeps_conf
-
+run-child \
+    "$LP_TRUNK_PATH/utilities/update-sourcecode" \
+    "$LP_SOURCEDEPS_PATH" "$sourcedeps_conf"
 
 # Update the current trees in the repo.
 echo "Updating sourcecode dependencies in current local branches:"
-for branch in "$LP_PROJECT_PATH"/*
-do
-    if [ -d "$branch/sourcecode" ]
-    then
-        echo "    ${branch}"
-        run-child "$LP_TRUNK_PATH/utilities/link-external-sourcecode" \
-            --parent="$LP_PROJECT_ROOT/$LP_SOURCEDEPS_DIR" --target="$branch"
-    fi
-done
+find "$LP_PROJECT_PATH" -mindepth 2 -maxdepth 2 \
+    -type d -name sourcecode -printf '%h\0' | \
+    run-child xargs --no-run-if-empty \
+        --max-procs="${CPU_COUNT}" --max-args=1 --null \
+        "$LP_TRUNK_PATH/utilities/link-external-sourcecode" \
+            --parent "$LP_PROJECT_ROOT/$LP_SOURCEDEPS_DIR" --target
 
 # Build launchpad if there were changes.
 if [ $FINAL_REV != $INITIAL_REV ];

